package org.jgroups.tests;

import org.jgroups.JChannel;
import org.jgroups.Message;
import org.jgroups.ReceiverAdapter;

import java.io.FileNotFoundException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author Bela Ban
 * @since x.y
 */
public class bla {

    public static void main(String[] args) throws Exception {
        JChannel jChannel = new JChannel("/home/bela/demo.xml");
        jChannel.connect("testing----");
        jChannel.setDiscardOwnMessages(true);
        jChannel.setReceiver(new ReceiverAdapter() {

            public void receive(Message msg) {

                long current = System.currentTimeMillis();

                System.out.println(new SimpleDateFormat("HH:mm:ss.sss").format(new Date(current)) +
                                     " msg received. size : " + msg.getLength());
            }
        });

        while (true) {
            System.in.read();
            System.out.println("Message sending.....");
            long current = System.currentTimeMillis();

            jChannel.send(new Message(null, new SimpleDateFormat("HH:mm:ss.sss").format(new Date(current))));
            Message message = new Message(null, getBytes());
            jChannel.send(message);
            System.out.println("Message send complete.Time used " + (System.currentTimeMillis() - current));
        }
    }

    private static byte[] getBytes() throws FileNotFoundException {
        //10M
        int len = 10 * 1024 * 1024;
        byte[] data = new byte[len];
        for (int i = 0; i < len; i++) {
            data[i] = 1;
        }

        return data;
    }

}



